package gui;

import static javafx.scene.control.Alert.AlertType.*;

import java.util.HashMap;

import javafx.scene.control.Alert;

public class Messages {

	// warnings & errors
	public static final String WARNING_CORPUS_NOT_FOUND = "V izbranem direktoriju ni ustreznih korpusnih datotek.";
	public static final String WARNING_RESULTS_DIR_NOT_VALID = "Za dostop do izbranega direktorija nimate potrebnih pravic.";
	public static final String WARNING_DIFFERING_NGRAM_LEVEL_AND_FILTER_TOKENS = "Izbran nivo ngramov in vpisano št. besed v filtru se ne ujemata.";
	public static final String WARNING_DIFFERING_NGRAM_LEVEL_AND_FILTER_TOKENS_INFO = "Izberite drugo število ali popravite filter.";
	public static final String WARNING_WORD_OR_LEMMA = "Izberite, če želite statistiko izračunati za besede ali leme.";
	public static final String WARNING_ONLY_NUMBERS_ALLOWED = "Prosim vnesite veljavno število.";
	public static final String WARNING_MISMATCHED_NGRAM_AND_TOKENS_VALUES = "Število za ngram (%d) in število msd oznak (%d) se morata ujemati.";
	public static final String WARNING_MISSING_STRING_LENGTH = "Dolžina niza mora biti večja od 0. Vstavljena je privzeta vrednost (1).";
	public static final String WARNING_NO_TAXONOMY_FOUND = "Iz korpusnih datotek ni bilo moč razbrati taksonomije. Prosim izberite drugo lokacijo ali korpus.";
	public static final String WARNING_NO_SOLAR_FILTERS_FOUND = "Iz korpusnih datotek ni bilo moč razbrati filtrov. Prosim izberite drugo lokacijo ali korpus.";
	public static final String ERROR_WHILE_EXECUTING = "Prišlo je do napake med izvajanjem.";
	public static final String ERROR_WHILE_SAVING_RESULTS_TO_CSV = "Prišlo je do napake med shranjevanje rezultatov.";

	// missing
	public static final String MISSING_NGRAM_LEVEL = "N-gram nivo";
	public static final String MISSING_CALCULATE_FOR = "Izračunaj za";
	public static final String MISSING_SKIP = "";
	public static final String MISSING_STRING_LENGTH = "Dolžina niza";
	public static final String MISMATCHED_STRING_LENGTH_AND_MSD_REGEX = "Neujemajoča dolžina niza in regex filter";


	// general notifications - static content/set only once
	public static final String NOTIFICATION_FOUND_X_FILES = "Št. najdenih datotek: %d";
	public static final String NOTIFICATION_ANALYSIS_COMPLETED = "Analiza je zaključena, rezultati so shranjeni.";
	public static final String NOTIFICATION_ANALYSIS_COMPLETED_NO_RESULTS = "Analiza je zaključena, vendar ni bilo moč izračunati statistike, ki bi ustrezala vsem navedenim pogojem.";
	public static final String RESULTS_PATH_SET_TO_DEFAULT = "Lokacija za shranjevanje rezultatov je nastavljena na lokacijo korpusa.";
	public static final String NOTIFICATION_ANALYSIS_CANCLED = "Analiziranje je bilo prekinjeno.";

	// ongoing notifications - displayed while processing, dynamically changing
	public static final String ONGOING_NOTIFICATION_ANALYZING_FILE_X_OF_Y = "Analiziram datoteko %d od %d (%s)";
	public static final String CANCELING_NOTIFICATION = "Prekinjeno";

	// Labels
	public static final String LABEL_CORPUS_LOCATION_NOT_SET = "Lokacija korpusa ni nastavljena";
	public static final String LABEL_RESULTS_LOCATION_NOT_SET = "Lokacija za shranjevanje rezultatov ni nastavljena";
	public static final String LABEL_RESULTS_CORPUS_TYPE_NOT_SET = "Vrsta korpusa ni nastavljena";

	public static final String LABEL_SCANNING_CORPUS = "Iskanje in analiza korpusnih datotek...";
	public static final String LABEL_SCANNING_SINGLE_FILE_CORPUS = "Analiza vnosa ";
	public static final String COMPLETED = "končano";

	public static final String TOOLTIP_chooseCorpusLocationB = "Izberite mapo v kateri se nahaja korpus. Program izbrano mapo preišče rekurzivno, zato bodite pozorni, da ne izberete mape z več korpusi ali z mnogo datotekami, ki niso del korpusa.";
	public static final String TOOLTIP_readHeaderInfoChB = "Če izberete to opcijo, se bo iz headerjev korpusa prebrala razpoložljiva taksonomija oz. filtri (korpus Šolar). Ta operacija lahko traja dlje časa, sploh če je korpus združen v eni sami datoteki.";



	// Not properly to be here. TODO move somewhere else in future
	public static final String HELP_URL = "http://slovnica.ijs.si/";

	// helper maps
	/**
	 * Typical window titles
	 * ERROR = "Napaka"
	 * WARNING = "Opozorilo"
	 * CONFIRMATION = "Potrdilo"
	 */
	static HashMap<Alert.AlertType, String> windowTitles = new HashMap<>();

	static {
		// automatically set window's title
		windowTitles.put(ERROR, "Napaka");
		windowTitles.put(WARNING, "Opozorilo");
		windowTitles.put(CONFIRMATION, "Potrdilo");
	}
}
